Index: trunk/LMDZ.MARS/README
===================================================================
--- trunk/LMDZ.MARS/README	(revision 1973)
+++ trunk/LMDZ.MARS/README	(revision 1974)
@@ -2613,2 +2613,7 @@
 Cosmetic changes:
 - variables suffixes for sub-grid scale cloud scheme changed from --1 to --clf
+
+== 18/07/2018 == EM+MV
+Integration of the detached dust layer parametrizations (rocket dust storm, slope wind lifting, CW, and dust injection scheme, DB).
+Still experimental, default behaviour (rdstorm=.false., dustinjection=0) identical to previous revision.
+NB: Updated newstart requires an updated "surface.nc" containing the "hmons" field.
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/avg_horiz_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/avg_horiz_mod.F	(revision 1974)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/avg_horiz_mod.F	(revision 1974)
@@ -0,0 +1,94 @@
+      MODULE avg_horiz_mod
+
+      IMPLICIT NONE
+
+      CONTAINS
+      
+      subroutine avg_horiz(imo,jmo,imn,jmn,rlonuo,rlatvo,rlonv,
+     .             rlatu,zdata,outdata)
+
+c=======================================================================
+c Maximum/minimum value composite approach for interpolate the variables
+c  from surface.nc (summit, base... ) 
+c  Chao Wang
+c=======================================================================
+
+      implicit none
+      !inputs/outputs
+      integer, intent(in)  ::  imo,jmo
+      integer, intent(in)  :: imn,jmn
+      real, intent(in)  :: rlonv(imn+1)    
+      real, intent(in)  :: rlatu(jmn+1)   
+      real, intent(in)  :: zdata(imo*jmo)
+      real, intent(out)  :: outdata(imn+1,jmn+1)
+
+      !local variables:
+      real pi
+      integer i,j,l,m,n
+      real tmplon(imn+2)
+      real tmplat(jmn+2)
+      real rlonuo(imo)    
+      real rlatvo(jmo)   
+
+      integer iik(imo,jmo),jjk(imo,jmo)
+      integer tmp
+      integer nmesh
+      
+c     initialize 
+      iik(:,:)=0
+      jjk(:,:)=0
+      outdata(:,:)=0.
+      pi=2.*ASIN(1.)
+
+      tmplon(1)=rlonv(1)
+      do i=2,imn+1
+        tmplon(i)= (rlonv(i-1)+rlonv(i))/2.
+      enddo
+      tmplon(imn+2)=rlonv(imn+1)
+
+      tmplat(1)=rlatu(1)
+      do j=2,jmn+1
+        tmplat(j)=(rlatu(j-1)+rlatu(j))/2.
+      enddo
+      tmplat(jmn+2)=rlatu(jmn+1)
+
+
+      do i=1,imo 
+        do j=1,jmo
+          do m=1,imn+1
+            do n=1,jmn+1
+              
+              if ( ((rlonuo(i) .ge. tmplon(m)) .and.
+     &                       (rlonuo(i) .lt. tmplon(m+1))) .and.
+     &           ((rlatvo(j) .lt. tmplat(n) ) .and.
+     &            (rlatvo(j) .ge. tmplat(n+1) ))) then
+                iik(i,j)=m
+                jjk(i,j)=n
+                goto 1000
+              endif
+              
+            enddo 
+          enddo
+1000      continue
+        enddo
+      enddo
+
+      do m=1,imn+1
+        do n=1,jmn+1
+          nmesh=0
+          do i=1,imo 
+            do j=1,jmo
+               if ((iik(i,j) .eq. m) .and. (jjk(i,j) .eq. n)) then
+                  outdata(m,n)=outdata(m,n)+zdata(i+imo*(j-1)) 
+                  nmesh=nmesh+1
+               endif       
+
+            enddo 
+          enddo
+          outdata(m,n)=outdata(m,n)/nmesh
+        enddo
+      enddo
+      
+      END SUBROUTINE avg_horiz
+
+      END MODULE avg_horiz_mod
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/datareadnc.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/datareadnc.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/datareadnc.F	(revision 1974)
@@ -1,5 +1,6 @@
 c=======================================================================
       SUBROUTINE datareadnc(relief,phisinit,alb,ith,z0,
-     &                    zmea,zstd,zsig,zgam,zthe)
+     &                    zmea,zstd,zsig,zgam,zthe,
+     &                    hmons,summit,zavg)
 c=======================================================================
 c
@@ -42,7 +43,10 @@
 c=======================================================================
 
-      use ioipsl_getincom, only: getin
-      USE comconst_mod, ONLY: g,pi
+! to use  'getin'
+      use ioipsl_getincom, only: getin 
+      use comconst_mod, only: g,pi
       use datafile_mod, only: datadir
+      use avg_horiz_mod, only: avg_horiz
+      use mvc_horiz_mod, only: mvc_horiz
 
       implicit none
@@ -74,5 +78,8 @@
       REAL,intent(out) :: zgam(imdp1*jmdp1)
       REAL,intent(out) :: zthe(imdp1*jmdp1)
-
+      REAL,intent(out) :: hmons(imdp1*jmdp1) !CW17,361*180 hmons
+      REAL,intent(out) :: summit(imdp1*jmdp1) !CW17,361*180 hmons
+      REAL,intent(out) :: zavg(imdp1*jmdp1) !CW17,361*180 hmons
+      
 ! Local variables:
       REAL        zdata(imd*jmdp1)
@@ -95,5 +102,5 @@
 
       CHARACTER*20 string
-      DIMENSION string(0:4)
+      DIMENSION string(0:6)
 
 
@@ -233,4 +240,19 @@
           call grid_noro1(360, 180, longitude, latitude, zdata,
      .         iim, jjp1, rlonv, rlatu, zmea,zstd,zsig,zgam,zthe)
+     
+          !CW17
+          call avg_horiz(imd,jmdp1,iim,jjm,longitude,
+     .                latitude,rlonv,rlatu,zdata,pfield)
+
+          do j=1,jjp1 !CW17 49, iimp1=65, the last column = first column
+             pfield(iimp1*j) =  pfield(1+iimp1*(j-1))
+          enddo 
+          do i=1,iimp1*jjp1
+c             if (pfield(i) .ne. -999999.) then
+                zavg(i) = pfield(i)
+c             else
+c               zavg(i)=-999999.
+c             endif
+          enddo
 
       endif
@@ -297,4 +319,95 @@
 c    FIN
 c-----------------------------------------------------------------------
-
+ 
+c=======================================================================
+c<<<<<<<<<<<<<<<<<<<<<<<add new dataset>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! name of dataset
+      string(5) = 'hmons' !subgrid hmons
+c     the following data could be useful in future, but currently,
+c     we don't need to put them into restartfi.nc
+      string(6) = 'summit' !subgrid summit
+c     string(7) = 'base'   !base of summit (not subgrid)
+c     string(8) = 'bottom' !subgrid base
+      do k=5,6
+          write(*,*) 'string',k,string(k)  
+c-----------------------------------------------------------------------
+c    Lecture NetCDF  
+c-----------------------------------------------------------------------
+
+          ierr = NF_INQ_VARID (unit, string(k), nvarid)
+          if (ierr.ne.nf_noerr) then
+            write(*,*) 'datareadnc error, cannot find ',trim(string(k))
+            write(*,*) ' in file ',trim(datadir),'/surface.nc'
+            stop
+          endif
+
+c-----------------------------------------------------------------------
+c    initialisation
+c-----------------------------------------------------------------------
+          call initial0(iimp1*jjp1,pfield)
+          call initial0(imd*jmdp1,zdata)
+          call initial0(imdp1*jmdp1,zdataS)
+
+#ifdef NC_DOUBLE
+          ierr = NF_GET_VAR_DOUBLE(unit, nvarid, zdata)
+#else
+          ierr = NF_GET_VAR_REAL(unit, nvarid, zdata)
+#endif
+          if (ierr.ne.nf_noerr) then
+            write(*,*) 'datareadnc: error failed loading ',
+     .                  trim(string(k))
+            stop
+          endif
+
+c-----------------------------------------------------------------------
+c   Passage de zdata en grille (imdp1 jmdp1)
+c-----------------------------------------------------------------------
+          do j=1,jmdp1     !  180
+              do i=1,imd   !  360
+                  !copy zdata to zdataS, line by line
+                  !      i+ 361 *(j-1)          i+  360*(j-1)
+                  zdataS(i+imdp1*(j-1)) = zdata(i+ngridmxgdat*(j-1))
+              enddo
+              ! the last column = the first column of zdata
+              zdataS(imdp1+imdp1*(j-1)) = zdata(1+ngridmxgdat*(j-1))
+          enddo
+
+          if (k .eq. 5 .or. k .eq. 6) then 
+              ! hmons, summit, keep the maximum of subgrids 
+              call mvc_horiz(imd,jmdp1,iim,jjm,longitude,
+     .                latitude,rlonv,rlatu,zdata,pfield)
+          endif
+
+
+c-----------------------------------------------------------------------
+c    Periodicite    
+c-----------------------------------------------------------------------
+
+          do j=1,jjp1 ! 49, iimp1=65, the last column = first column
+             pfield(iimp1*j) =  pfield(1+iimp1*(j-1))
+          enddo 
+ 
+c-----------------------------------------------------------------------
+c    Sauvegarde des champs    
+c-----------------------------------------------------------------------
+
+          if (k.eq.5) then ! hmons
+             do i=1,iimp1*jjp1
+                  if (pfield(i) .ne. -999999.) then
+                    hmons(i) = pfield(i)
+                  else
+                    hmons(i)=0.
+                  endif
+             enddo
+          endif
+          
+          if (k.eq.6) then  ! summit
+             do i=1,iimp1*jjp1
+                    summit(i) = pfield(i)
+             enddo
+          endif
+
+      enddo
+c<<<<<<<<<<<<<<<<<<<<<<<<<done add new dataset>>>>>>>>>>>>>>>>>>>>>>>>>>
+c=======================================================================
       END
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/mvc_horiz_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/mvc_horiz_mod.F	(revision 1974)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/mvc_horiz_mod.F	(revision 1974)
@@ -0,0 +1,93 @@
+      MODULE mvc_horiz_mod
+      
+      implicit none
+      
+      contains      
+
+      subroutine mvc_horiz(imo,jmo,imn,jmn,rlonuo,rlatvo,rlonv,
+     .             rlatu,zdata,outdata)
+
+c=======================================================================
+c Maximum/minimum value composite approach for interpolate the variables
+c  from surface.nc (summit, base... ) 
+c  Chao Wang
+c=======================================================================
+
+      implicit none
+      
+      !inputs/ouputs
+      integer, intent(in) :: imo,jmo
+      integer, intent(in) :: imn,jmn
+      real, intent(in)    ::  rlonv(imn+1)    
+      real, intent(in)    ::  rlatu(jmn+1)   
+      real, intent(in)    ::  zdata(imo*jmo)
+      real, intent(out)   ::   outdata(imn+1,jmn+1)
+      
+      !local variables:
+      real pi
+      integer i,j,l,m,n
+      real tmplon(imn+2)
+      real tmplat(jmn+2)
+      REAL rlonuo(imo)    
+      REAL rlatvo(jmo)   
+
+      integer iik(imo,jmo),jjk(imo,jmo)
+      integer tmp
+
+c     initialize 
+      iik(:,:)=0
+      jjk(:,:)=0
+      outdata(:,:)=-999999. !lowest point on Mars ~8200m
+
+      pi=2.*ASIN(1.)
+
+      tmplon(1)=rlonv(1)
+      do i=2,imn+1
+        tmplon(i)= (rlonv(i-1)+rlonv(i))/2.
+      enddo
+      tmplon(imn+2)=rlonv(imn+1)
+
+      tmplat(1)=rlatu(1)
+      do j=2,jmn+1
+        tmplat(j)=(rlatu(j-1)+rlatu(j))/2.
+      enddo
+      tmplat(jmn+2)=rlatu(jmn+1)
+
+
+      do i=1,imo 
+        do j=1,jmo
+          do m=1,imn+1
+            do n=1,jmn+1
+              
+              if ( ((rlonuo(i) .ge. tmplon(m)) .and.
+     &                       (rlonuo(i) .lt. tmplon(m+1))) .and.
+     &           ((rlatvo(j) .lt. tmplat(n) ) .and.
+     &            (rlatvo(j) .ge. tmplat(n+1) ))) then
+                iik(i,j)=m
+                jjk(i,j)=n
+                goto 1000
+              endif
+              
+            enddo 
+          enddo
+1000      continue
+        enddo
+      enddo
+
+      do m=1,imn+1
+        do n=1,jmn+1
+          do i=1,imo 
+            do j=1,jmo
+
+               if ((iik(i,j) .eq. m) .and. (jjk(i,j) .eq. n)) then
+                  outdata(m,n)=max(outdata(m,n),zdata(i+imo*(j-1))  )
+               endif       
+
+            enddo 
+          enddo
+        enddo
+      enddo
+
+      end subroutine mvc_horiz
+      
+      END MODULE mvc_horiz_mod
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F	(revision 1974)
@@ -27,5 +27,5 @@
       use surfdat_h, only: phisfi, z0, zmea, zstd, zsig, zgam, zthe,
      &                     albedodat, z0_default, qsurf, tsurf,
-     &                     co2ice, emis
+     &                     co2ice, emis, hmons
       use comsoil_h, only: inertiedat, layer, mlayer, nsoilmx, tsoil
       use control_mod, only: day_step, iphysiq, anneeref, planet_type
@@ -97,4 +97,7 @@
       real zmeaS(iip1,jjp1),zstdS(iip1,jjp1)
       real zsigS(iip1,jjp1),zgamS(iip1,jjp1),ztheS(iip1,jjp1)
+      real hmonsS(iip1,jjp1)
+      real summitS(iip1,jjp1)
+      real zavgS(iip1,jjp1)
       real z0S(iip1,jjp1)
 
@@ -380,5 +383,6 @@
 
       CALL datareadnc(relief,phis,alb,surfith,z0S,
-     &          zmeaS,zstdS,zsigS,zgamS,ztheS)
+     &          zmeaS,zstdS,zsigS,zgamS,ztheS,
+     &          hmonsS,summitS,zavgS)
 
       CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,phis,phisfi)
@@ -392,4 +396,7 @@
       CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,zgamS,zgam)
       CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,ztheS,zthe)
+      CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,hmonsS,hmons)
+!      CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,summitS,summit)
+!      CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,zavgS,zavg)
 
       endif ! of if (choix_1.ne.1)
@@ -1642,5 +1649,6 @@
       call physdem0("restartfi.nc",lonfi,latfi,nsoilmx,ngridmx,llm,
      .              nqtot,dtphys,real(day_ini),0.0,
-     .              airefi,albfi,ithfi,zmea,zstd,zsig,zgam,zthe)
+     .              airefi,albfi,ithfi,zmea,zstd,zsig,zgam,zthe,
+     .              hmons)
       call physdem1("restartfi.nc",nsoilmx,ngridmx,llm,nqtot,
      &              dtphys,hour_ini,
Index: trunk/LMDZ.MARS/libf/phymars/aeropacity_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/aeropacity_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/aeropacity_mod.F	(revision 1974)
@@ -7,12 +7,13 @@
       SUBROUTINE aeropacity(ngrid,nlayer,nq,zday,pplay,pplev,ls,
      &    pq,tauscaling,tauref,tau,taucloudtes,aerosol,dsodust,reffrad,
-     &    nueffrad,QREFvis3d,QREFir3d,omegaREFvis3d,omegaREFir3d,
+     &    QREFvis3d,QREFir3d,omegaREFir3d,
+     &    totstormfract,clearatm,dsords,
      &    clearsky,totcloudfrac)
-                                                   
+                                                         
 ! to use  'getin'
       USE ioipsl_getincom, only: getin
       use tracer_mod, only: noms, igcm_h2o_ice, igcm_dust_mass,
      &                      igcm_dust_submicron, rho_dust, rho_ice,
-     &                      nqdust
+     &                      nqdust, igcm_stormdust_mass
       use geometry_mod, only: latitude ! grid point latitudes (rad)
       use comgeomfi_h, only: sinlat ! sines of grid point latitudes
@@ -26,5 +27,7 @@
      &            iaerdust,tauvis,
      &            iaer_dust_conrath,iaer_dust_doubleq,
-     &            iaer_dust_submicron,iaer_h2o_ice
+     &            iaer_dust_submicron,iaer_h2o_ice,
+     &            iaer_stormdust_doubleq
+      USE calcstormfract_mod
        IMPLICIT NONE
 c=======================================================================
@@ -56,5 +59,4 @@
 c   QREFvis3d(ngrid,nlayer,naerkind) \ 3d extinction coefficients
 c   QREFir3d(ngrid,nlayer,naerkind)  / at reference wavelengths;
-c   omegaREFvis3d(ngrid,nlayer,naerkind) \ 3d single scat. albedo
 c   omegaREFir3d(ngrid,nlayer,naerkind)  / at reference wavelengths;
 c
@@ -65,8 +67,8 @@
 c   aerosol      aerosol(ig,l,1) is the dust optical
 c                depth in layer l, grid point ig
-
+c   taualldust   CW17 total opacity for all dust scatterer stormdust included
 c
 c=======================================================================
-#include "callkeys.h"
+      include "callkeys.h"
 
 c-----------------------------------------------------------------------
@@ -77,25 +79,27 @@
 c    Input/Output
 c    ------------
-      INTEGER ngrid,nlayer,nq
-
-      REAL ls,zday,expfactor    
-      REAL pplev(ngrid,nlayer+1),pplay(ngrid,nlayer)
-      REAL pq(ngrid,nlayer,nq)
-      REAL tauref(ngrid), tau(ngrid,naerkind)
-      REAL aerosol(ngrid,nlayer,naerkind)
-      REAL dsodust(ngrid,nlayer)
-      REAL reffrad(ngrid,nlayer,naerkind)
-      REAL nueffrad(ngrid,nlayer,naerkind)
-      REAL QREFvis3d(ngrid,nlayer,naerkind)
-      REAL QREFir3d(ngrid,nlayer,naerkind)
-      REAL omegaREFvis3d(ngrid,nlayer,naerkind)
-      REAL omegaREFir3d(ngrid,nlayer,naerkind)
-      real,intent(in) :: totcloudfrac(ngrid) ! total cloud fraction
-      logical,intent(in) :: clearsky ! true for part without clouds, 
-                                     ! false for part with clouds (total or sub-grid clouds)
-      real :: CLFtot ! total cloud fraction
+      INTEGER, INTENT(IN) ::  ngrid,nlayer,nq
+      REAL, INTENT(IN) :: ls,zday
+      REAL, INTENT(IN) ::  pplev(ngrid,nlayer+1),pplay(ngrid,nlayer)
+      REAL, INTENT(IN) ::  pq(ngrid,nlayer,nq)
+      REAL, INTENT(OUT) :: tauref(ngrid)
+      REAL, INTENT(OUT) :: tau(ngrid,naerkind)
+      REAL, INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind)
+      REAL, INTENT(OUT) ::  dsodust(ngrid,nlayer)
+      REAL, INTENT(OUT) ::  dsords(ngrid,nlayer) !dso of stormdust  
+      REAL, INTENT(INOUT) :: reffrad(ngrid,nlayer,naerkind)
+      REAL, INTENT(IN) :: QREFvis3d(ngrid,nlayer,naerkind)
+      REAL, INTENT(IN) :: QREFir3d(ngrid,nlayer,naerkind)
+      REAL, INTENT(IN) ::  omegaREFir3d(ngrid,nlayer,naerkind)
+      LOGICAL, INTENT(IN) :: clearatm
+      REAL, INTENT(IN) :: totstormfract(ngrid)
+      REAL, INTENT(OUT) ::  tauscaling(ngrid) ! Scaling factor for qdust and Ndust
+      REAL,INTENT(IN) :: totcloudfrac(ngrid) ! total cloud fraction
+      LOGICAL,INTENT(IN) :: clearsky ! true for part without clouds,false for part with clouds (total or sub-grid clouds)
 c
 c    Local variables :
 c    -----------------
+      REAL CLFtot ! total cloud fraction
+      real expfactor 
       INTEGER l,ig,iq,i,j
       INTEGER iaer           ! Aerosol index
@@ -110,7 +114,10 @@
 c       for dust or water ice particles in the radiative transfer
 c       (see callradite.F for more information).
-      REAL taudusttmp(ngrid)! Temporary dust opacity
-                               !   used before scaling
-      REAL tauscaling(ngrid) ! Scaling factor for qdust and Ndust
+      REAL taudusttmp(ngrid)! Temporary dust opacity used before scaling
+      REAL taubackdusttmp(ngrid)! Temporary background dust opacity used before scaling
+      REAL taualldust(ngrid)! dust opacity all dust
+      REAL taudust(ngrid)! dust opacity dust doubleq
+      REAL taustormdust(ngrid)! dust opacity stormdust doubleq
+      REAL taustormdusttmp(ngrid)! dust opacity stormdust doubleq before tauscaling
       REAL taudustvis(ngrid) ! Dust opacity after scaling
       REAL taudusttes(ngrid) ! Dust opacity at IR ref. wav. as
@@ -157,4 +164,6 @@
 
       tau(1:ngrid,1:naerkind)=0
+      dsords(:,:)=0. !CW17: initialize dsords
+      dsodust(:,:)=0.
 
 ! identify tracers
@@ -166,5 +175,6 @@
         DO iaer=1,naerkind
           txt=name_iaer(iaer)
-          IF (txt(1:4).eq."dust") THEN
+        ! CW17: choice tauscaling for stormdust or not
+          IF ((txt(1:4).eq."dust").OR.(txt(1:5).eq."storm")) THEN
             naerdust=naerdust+1
             iaerdust(naerdust)=iaer
@@ -213,8 +223,9 @@
         call getin("tauvis",tauvis)
 
-        IF (freedust) THEN
+        IF (freedust.or.rdstorm) THEN ! if rdstorm no need to held opacity constant at the first levels
           cstdustlevel = 1
         ELSE
-          cstdustlevel = cstdustlevel0
+          cstdustlevel = cstdustlevel0 !Opacity in the first levels is held constant to 
+                                       !avoid unrealistic values due to constant lifting
         ENDIF
 
@@ -374,8 +385,8 @@
      &          ( pplev(ig,l) - pplev(ig,l+1) ) / g
                 ! DENSITY SCALED OPACITY IN INFRARED:
-                dsodust(ig,l) =
-     &          (  0.75 * QREFir3d(ig,cstdustlevel,iaer) /
-     &          ( rho_dust * reffrad(ig,cstdustlevel,iaer) )  ) *
-     &          pq(ig,cstdustlevel,igcm_dust_mass)
+!                dsodust(ig,l) =
+!     &          (  0.75 * QREFir3d(ig,cstdustlevel,iaer) /
+!     &          ( rho_dust * reffrad(ig,cstdustlevel,iaer) )  ) *
+!     &          pq(ig,cstdustlevel,igcm_dust_mass)
               ENDDO
             ELSE
@@ -387,8 +398,8 @@
      &          ( pplev(ig,l) - pplev(ig,l+1) ) / g
                 ! DENSITY SCALED OPACITY IN INFRARED:
-                dsodust(ig,l) =
-     &          (  0.75 * QREFir3d(ig,l,iaer) /
-     &          ( rho_dust * reffrad(ig,l,iaer) )  ) *
-     &          pq(ig,l,igcm_dust_mass)
+!                dsodust(ig,l) =
+!     &          (  0.75 * QREFir3d(ig,l,iaer) /
+!     &          ( rho_dust * reffrad(ig,l,iaer) )  ) *
+!     &          pq(ig,l,igcm_dust_mass)
               ENDDO
             ENDIF
@@ -473,19 +484,36 @@
         ENDIF ! end (clearsky)
 
-c       3. Outputs -- Now done in physiq.F
-!        IF (ngrid.NE.1) THEN
-!          CALL WRITEDIAGFI(ngrid,'tauVIS','tauext VIS refwvl',
-!     &      ' ',2,taucloudvis)
-!          CALL WRITEDIAGFI(ngrid,'tauTES','tauabs IR refwvl',
-!     &      ' ',2,taucloudtes)
-!          IF (callstats) THEN
-!            CALL wstats(ngrid,'tauVIS','tauext VIS refwvl',
-!     &        ' ',2,taucloudvis)
-!            CALL wstats(ngrid,'tauTES','tauabs IR refwvl',
-!     &        ' ',2,taucloudtes)
-!          ENDIF
-!        ELSE
-!         CALL writeg1d(ngrid,1,taucloudtes,'tautes','NU')
-!        ENDIF
+c==================================================================
+        CASE("stormdust_doubleq") aerkind ! CW17 : Two-moment scheme for 
+c       stormdust  (transport of mass and number mixing ratio) 
+c==================================================================
+c       aerosol is calculated twice : once within the dust storm (clearatm=false)
+c       and once in the part of the mesh without dust storm (clearatm=true)
+        aerosol(1:ngrid,1:nlayer,iaer) = 0.
+        IF (clearatm) THEN  ! considering part of the mesh without storm
+          aerosol(1:ngrid,1:nlayer,iaer)=1.e-25
+        ELSE  ! part of the mesh with concentred dust storm
+          DO l=1,nlayer
+             IF (l.LE.cstdustlevel) THEN
+c          Opacity in the first levels is held constant to 
+c           avoid unrealistic values due to constant lifting:
+               DO ig=1,ngrid
+                  aerosol(ig,l,iaer) = 
+     &           (  0.75 * QREFvis3d(ig,cstdustlevel,iaer) /
+     &           ( rho_dust * reffrad(ig,cstdustlevel,iaer) )  ) *
+     &           pq(ig,cstdustlevel,igcm_stormdust_mass) *
+     &           ( pplev(ig,l) - pplev(ig,l+1) ) / g
+               ENDDO
+             ELSE
+              DO ig=1,ngrid
+                 aerosol(ig,l,iaer) =
+     &           (  0.75 * QREFvis3d(ig,l,iaer) /
+     &           ( rho_dust * reffrad(ig,l,iaer) )  ) *
+     &           pq(ig,l,igcm_stormdust_mass) *
+     &           ( pplev(ig,l) - pplev(ig,l+1) ) / g
+              ENDDO
+             ENDIF
+          ENDDO
+        ENDIF
 c==================================================================
         END SELECT aerkind
@@ -498,4 +526,5 @@
 c   is originally scaled to an equivalent odpref Pa pressure surface.
 c -----------------------------------------------------------------
+
 
 #ifdef DUSTSTORM
@@ -640,5 +669,22 @@
       IF (freedust) THEN
           tauscaling(:) = 1.
-
+c        opacity obtained with stormdust
+        IF (rdstorm) THEN
+           taustormdusttmp(1:ngrid)=0.
+           DO l=1,nlayer
+             DO ig=1,ngrid
+                taustormdusttmp(ig) = taustormdusttmp(ig)+ 
+     &            aerosol(ig,l,iaerdust(2))
+             ENDDO
+           ENDDO
+           !opacity obtained with background dust only
+           taubackdusttmp(1:ngrid)=0.  
+           DO l=1,nlayer
+             DO ig=1,ngrid
+                taubackdusttmp(ig) = taubackdusttmp(ig)+
+     &           aerosol(ig,l,iaerdust(1))
+             ENDDO
+           ENDDO
+        ENDIF !rdsstorm
       ELSE
 c       Temporary scaling factor
@@ -669,10 +715,4 @@
      &                aerosol(ig,l,iaerdust(iaer))* tauscaling(ig))
           ENDDO
-        ENDDO
-      ENDDO
-
-      DO l=1,nlayer
-        DO ig=1,ngrid
-          dsodust(ig,l) = max(1E-20,dsodust(ig,l)* tauscaling(ig))
         ENDDO
       ENDDO
@@ -700,17 +740,5 @@
         tauref(:) = tauref(:) * odpref / pplev(:,1)
       ENDIF
-      
-c output for debug
-c        IF (ngrid.NE.1) THEN
-c             CALL WRITEDIAGFI(ngrid,'taudusttmp','virtual tau dust',
-c     &      '#',2,taudusttmp)
-c             CALL WRITEDIAGFI(ngrid,'tausca','tauscaling',
-c     &      '#',2,tauscaling)
-c        ELSE
-c             CALL WRITEDIAGFI(ngrid,'taudusttmp','virtual tau dust',
-c     &      '#',0,taudusttmp)
-c             CALL WRITEDIAGFI(ngrid,'tausca','tauscaling',
-c     &      '#',0,tauscaling)
-c        ENDIF
+
 c -----------------------------------------------------------------
 c Column integrated visible optical depth in each point
@@ -724,4 +752,38 @@
       ENDDO
 
+c     for diagnostics: opacity for all dust scatterers stormdust included 
+      taualldust(1:ngrid)=0.
+      DO iaer=1,naerdust
+        DO l=1,nlayer
+          DO ig=1,ngrid
+            taualldust(ig) = taualldust(ig) + 
+     &                         aerosol(ig,l,iaerdust(iaer))
+          ENDDO
+        ENDDO
+      ENDDO
+     
+      IF (rdstorm) THEN
+ 
+c     for diagnostics: opacity for dust in background only  
+       taudust(1:ngrid)=0.
+        DO l=1,nlayer
+         DO ig=1,ngrid
+           taudust(ig) = taudust(ig) + 
+     &                       aerosol(ig,l,iaer_dust_doubleq)
+         ENDDO
+        ENDDO
+
+c     for diagnostics: opacity for dust in storm only  
+       taustormdust(1:ngrid)=0.
+        DO l=1,nlayer
+         DO ig=1,ngrid
+           taustormdust(ig) = taustormdust(ig) + 
+     &                       aerosol(ig,l,iaer_stormdust_doubleq)
+         ENDDO
+        ENDDO
+ 
+      ENDIF
+      
+
 #ifdef DUSTSTORM
       IF (firstcall) THEN
@@ -733,39 +795,42 @@
 c Density scaled opacity and column opacity output
 c -----------------------------------------------------------------
-c      dsodust(1:ngrid,1:nlayer) = 0.
-c      DO iaer=1,naerdust
-c        DO l=1,nlayer
-c          DO ig=1,ngrid
-c            dsodust(ig,l) = dsodust(ig,l) +
-c     &                      aerosol(ig,l,iaerdust(iaer)) * g /
-c     &                      (pplev(ig,l) - pplev(ig,l+1))
-c          ENDDO
-c        ENDDO
-c        IF (ngrid.NE.1) THEN
-c          write(txt2,'(i1.1)') iaer
-c          call WRITEDIAGFI(ngrid,'taudust'//txt2,
-c     &                    'Dust col opacity',
-c     &                    ' ',2,tau(1,iaerdust(iaer)))
-c          IF (callstats) THEN
-c            CALL wstats(ngrid,'taudust'//txt2,
-c     &                 'Dust col opacity',
-c     &                 ' ',2,tau(1,iaerdust(iaer)))
-c          ENDIF
-c        ENDIF
-c      ENDDO
-
-c      IF (ngrid.NE.1) THEN
-c       CALL WRITEDIAGFI(ngrid,'dsodust','tau*g/dp',
-c    &                    'm2.kg-1',3,dsodust)
-c        IF (callstats) THEN
-c          CALL wstats(ngrid,'dsodust',
-c     &               'tau*g/dp',
-c     &               'm2.kg-1',3,dsodust)
-c        ENDIF
-c      ELSE
-c        CALL WRITEDIAGFI(ngrid,"dsodust","dsodust","m2.kg-1",1,
-c     &                   dsodust)
-c      ENDIF ! of IF (ngrid.NE.1)
-c -----------------------------------------------------------------
+          IF (rdstorm) then
+            DO l=1,nlayer
+              IF (l.LE.cstdustlevel) THEN
+                DO ig=1,ngrid 
+                  dsodust(ig,l)=dsodust(ig,l) +
+     &                      aerosol(ig,l,iaer_dust_doubleq) * g /
+     &                      (pplev(ig,l) - pplev(ig,l+1))
+
+                  dsords(ig,l) = dsords(ig,l) +
+     &              aerosol(ig,l,iaer_stormdust_doubleq)* g/
+     &              (pplev(ig,l) - pplev(ig,l+1))
+                ENDDO
+              ELSE
+                DO ig=1,ngrid
+                  dsodust(ig,l) =dsodust(ig,l) +
+     &                      aerosol(ig,l,iaer_dust_doubleq) * g /
+     &                      (pplev(ig,l) - pplev(ig,l+1))
+                   dsords(ig,l) = dsords(ig,l) +
+     &                        aerosol(ig,l,iaer_stormdust_doubleq)* g/
+     &                        (pplev(ig,l) - pplev(ig,l+1))
+                ENDDO
+              ENDIF
+            ENDDO
+          ENDIF
+
+c -----------------------------------------------------------------
+c -----------------------------------------------------------------
+c aerosol/X for stormdust to prepare calculation of radiative transfer
+c -----------------------------------------------------------------
+      if (rdstorm) then
+         DO l=1,nlayer
+           DO ig=1,ngrid
+               aerosol(ig,l,iaer_stormdust_doubleq) = 
+     &           aerosol(ig,l,iaer_stormdust_doubleq)/totstormfract(ig)
+           ENDDO
+         ENDDO
+      endif 
+
 
       END SUBROUTINE aeropacity
